/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "application.h"
#include "window.h"
#include "graphics.h"
#include "ticker.h"

namespace magnum { namespace sample {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool SampleApplication::onRun() {
	m_Window = new MainWindow();
	m_Graphics = new GraphicsView(magnum::graphics::Rectangle<float>(0,0,300,300));
	m_Graphics->setAlignement(magnum::gui::View::FollowAll);
	m_Window->insert(m_Graphics);

	m_Window->open();

	m_Ticker = new RedrawTicker(m_Graphics);
	m_Ticker->setFrequency(20);
	m_Ticker->start();
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool SampleApplication::onQuit() {
	m_Ticker->kill();
	m_Window->close();
	m_Ticker->release();
	m_Window->release();
	m_Graphics->release();
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool SampleApplication::onHandleMessage(const Message& msg) {
	return true;
}

}; };
