/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "gui.h"

namespace magnum { namespace sample {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Gui::Gui(magnum::graphics3d::Context* context) : Root(context) {
	m_Translation[0] = m_Translation[1] = m_Translation[2] = 0.0f;
	m_Rotation[0] = m_Rotation[1] = 0.0f;

	m_Transform.identity();
	m_Transform.translate(- Vector3<float>(0.0f, 0.0f, 400.0f));
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Gui::~Gui() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Gui::onMouseMove(const Point<float>& pt, Mouse::Button but) {
	if (Root::onMouseMove(pt, but))
		return true;
		
	m_OldMouse = m_Mouse;
	m_Mouse = pt;
//	if(mx & 1 << 15) mx -= (1 << 16);
//	if(my & 1 << 15) my -= (1 << 16);

	float dx = m_OldMouse.getX() - m_Mouse.getX();
    float dy = m_Mouse.getY() - m_OldMouse.getY();

	if (but & Mouse::LeftDown) {
		m_Translation[0] -= dx / 10.0f;
		m_Translation[1] -= dy / 10.0f;
	}
	if (but & Mouse::MiddleDown) {
		m_Rotation[0] += (dy * 180.0f) / 500.0f;
		m_Rotation[1] -= (dx * 180.0f) / 500.0f;
	#define clamp(x) x = x > 360.0f ? x-360.0f : x < -360.0f ? x+=360.0f : x
		clamp(m_Rotation[0]);
		clamp(m_Rotation[1]);
	}
	if (but & Mouse::RightDown) {
		m_Translation[2] -= (dx+dy) / 10.0f;
    }

	m_Transform.identity();
    m_Transform.rotate((float)(m_Rotation[0]/180*M_PI), Vector3<float>(1.0f, 0.0f, 1.0f));
    m_Transform.rotate((float)(m_Rotation[1]/180*M_PI), Vector3<float>(0.0f, 1.0f, 0.0f));
	m_Transform.translate(m_Translation - Vector3<float>(0.0f, 0.0f, 400.0f));

	if (but & Mouse::AnyDown)
		invalidate();

	return true;
}

}; };
