/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SAMPLE_GUI_H
#define __SAMPLE_GUI_H

#include "magnum.h"

namespace magnum { namespace sample {
using magnum::gui3d::Root;
using magnum::gui3d::Button;
using magnum::gui3d::FontMap;
using magnum::freetype::Font;
using magnum::graphics::Point;
using magnum::math::Vector3;
using magnum::application::Mouse;
using magnum::geometry::Transform3;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Gui : public Root {
DeclareClass(Gui, Root);
private:
	Font*				m_Font;
	Button*				m_EnableGuiButton;
	
	Vector3<float>		m_Translation;			/* current translation */
	Point<float>		m_Rotation;				/* current rotation */
	Point<float>		m_Mouse, m_OldMouse;
	Transform3<float>	m_Transform;
	

public:
	Gui(magnum::graphics3d::Context* );
	~Gui();
	
	inline const Vector3<float>& getTranslation() const;
	inline const Point<float>& getRotation() const;
	inline const Point<float>& getMouse() const;
	inline const Transform3<float>& getTransform() const;

protected:
	virtual bool		onMouseMove(const Point<float>& ,Mouse::Button );
};

}; };

#endif
